diff --git a/src/backend/access/gist/gistvacuum.c b/src/backend/access/gist/gistvacuum.c
index 686a04180..ccfca91fa 100644
--- a/src/backend/access/gist/gistvacuum.c
+++ b/src/backend/access/gist/gistvacuum.c
@@ -326,10 +326,17 @@ restart:
 	recurse_to = InvalidBlockNumber;
 
 	/*
-	 * We are not going to stay here for a long time, aggressively grab an
-	 * exclusive lock.
+	 * Get a full cleanup lock on this page.  We must get such a lock on every
+	 * leaf page over the course of the vacuum scan, whether or not it
+	 * actually contains any deletable tuples.
+	 *
+	 * Note: we could avoid this for internal pages, but not for the root
+	 * page.  The root page can start out as a leaf page, but subsequently
+	 * become an internal page, even while a scan holds an interlock pin on
+	 * that page (this isn't possible in nbtree because root splits always
+	 * create a new root page, stored within a separate block number).
 	 */
-	LockBuffer(buffer, GIST_EXCLUSIVE);
+	LockBufferForCleanup(buffer);
 	page = BufferGetPage(buffer);
 
 	if (gistPageRecyclable(page))
@@ -407,9 +414,8 @@ restart:
 			{
 				XLogRecPtr	recptr;
 
-				recptr = gistXLogUpdate(buffer,
-										todelete, ntodelete,
-										NULL, 0, InvalidBuffer);
+				recptr = gistXLogUpdate(buffer, todelete, ntodelete,
+										NULL, 0, InvalidBuffer, true);
 				PageSetLSN(page, recptr);
 			}
 			else
diff --git a/src/backend/access/gist/gistxlog.c b/src/backend/access/gist/gistxlog.c
index ae538dc81..2fa5190c7 100644
--- a/src/backend/access/gist/gistxlog.c
+++ b/src/backend/access/gist/gistxlog.c
@@ -67,14 +67,15 @@ gistRedoClearFollowRight(XLogReaderState *record, uint8 block_id)
  * redo any page update (except page split)
  */
 static void
-gistRedoPageUpdateRecord(XLogReaderState *record)
+gistRedoPageUpdateRecord(XLogReaderState *record, bool get_cleanup_lock)
 {
 	XLogRecPtr	lsn = record->EndRecPtr;
 	gistxlogPageUpdate *xldata = (gistxlogPageUpdate *) XLogRecGetData(record);
 	Buffer		buffer;
 	Page		page;
 
-	if (XLogReadBufferForRedo(record, 0, &buffer) == BLK_NEEDS_REDO)
+	if (XLogReadBufferForRedoExtended(record, 0, RBM_NORMAL, get_cleanup_lock,
+									  &buffer) == BLK_NEEDS_REDO)
 	{
 		char	   *begin;
 		char	   *data;
@@ -407,7 +408,10 @@ gist_redo(XLogReaderState *record)
 	switch (info)
 	{
 		case XLOG_GIST_PAGE_UPDATE:
-			gistRedoPageUpdateRecord(record);
+			gistRedoPageUpdateRecord(record, false);
+			break;
+		case XLOG_GIST_PAGE_VACUUM:
+			gistRedoPageUpdateRecord(record, true);
 			break;
 		case XLOG_GIST_DELETE:
 			gistRedoDeleteRecord(record);
@@ -598,6 +602,11 @@ gistXLogPageReuse(Relation rel, Relation heaprel,
  * If this update inserts a downlink for a split page, also record that
  * the F_FOLLOW_RIGHT flag on the child page is cleared and NSN set.
  *
+ * A VACUUM deletion of leaf index tuples uses the same on-page
+ * representation, but caller passes vacuum=true so that the record is logged
+ * under a distinct record type, telling replay to take a cleanup lock on the
+ * target page.
+ *
  * Note that both the todelete array and the tuples are marked as belonging
  * to the target buffer; they need not be stored in XLOG if XLogInsert decides
  * to log the whole buffer contents instead.
@@ -606,12 +615,14 @@ XLogRecPtr
 gistXLogUpdate(Buffer buffer,
 			   OffsetNumber *todelete, int ntodelete,
 			   IndexTuple *itup, int ituplen,
-			   Buffer leftchildbuf)
+			   Buffer leftchildbuf, bool vacuum)
 {
 	gistxlogPageUpdate xlrec;
 	int			i;
 	XLogRecPtr	recptr;
 
+	Assert(!vacuum || (ituplen == 0 && !BufferIsValid(leftchildbuf)));
+
 	xlrec.ntodelete = ntodelete;
 	xlrec.ntoinsert = ituplen;
 
@@ -632,7 +643,8 @@ gistXLogUpdate(Buffer buffer,
 	if (BufferIsValid(leftchildbuf))
 		XLogRegisterBuffer(1, leftchildbuf, REGBUF_STANDARD);
 
-	recptr = XLogInsert(RM_GIST_ID, XLOG_GIST_PAGE_UPDATE);
+	recptr = XLogInsert(RM_GIST_ID,
+						vacuum ? XLOG_GIST_PAGE_VACUUM : XLOG_GIST_PAGE_UPDATE);
 
 	return recptr;
 }
diff --git a/src/backend/access/hash/hash.c b/src/backend/access/hash/hash.c
index aa3149960..007a40ebd 100644
--- a/src/backend/access/hash/hash.c
+++ b/src/backend/access/hash/hash.c
@@ -118,6 +118,7 @@ hashhandler(PG_FUNCTION_ARGS)
 		.amgetbatch = hashgetbatch,
 		.amunguardbatch = hashunguardbatch,
 		.amkillitemsbatch = hashkillitemsbatch,
+		.amgettransform = NULL,
 		.amgetbitmap = hashgetbitmap,
 		.amendscan = hashendscan,
 		.amposreset = NULL,
diff --git a/src/backend/access/heap/heapam_indexscan.c b/src/backend/access/heap/heapam_indexscan.c
index d7214a1df..12f38f16f 100644
--- a/src/backend/access/heap/heapam_indexscan.c
+++ b/src/backend/access/heap/heapam_indexscan.c
@@ -837,11 +837,23 @@ heapam_index_return_scanpos_tid(IndexScanDesc scan, IndexScanHeapData *hscan,
 								BatchRingItemPos *scanPos,
 								bool *all_visible)
 {
+	amgettransform_function amgettransform =
+		scan->indexRelation->rd_indam->amgettransform;
 	HeapBatchData *hbatch;
 
 	/* Set xs_heaptid, which caller (and core executor) will need */
 	scan->xs_heaptid = scanBatch->items[scanPos->item].tableTid;
 
+	/*
+	 * Let the index AM set this item's per-tuple output.  An AM that provides
+	 * amgettransform uses it to set the item's qual recheck flag
+	 * (scan->xs_recheck), an ordered scan's ORDER BY distances
+	 * (xs_orderbyvals/xs_recheckorderby), and an index-only scan's returnable
+	 * tuple (xs_hitup).
+	 */
+	if (amgettransform != NULL)
+		amgettransform(scan, scanBatch, scanPos->item);
+
 	if (all_visible == NULL)
 	{
 		/*
@@ -854,8 +866,14 @@ heapam_index_return_scanpos_tid(IndexScanDesc scan, IndexScanHeapData *hscan,
 	/* Index-only scan */
 	Assert(scan->xs_want_itup);
 
-	scan->xs_itup = (IndexTuple) (scanBatch->currTuples +
-								  scanBatch->items[scanPos->item].tupleOffset);
+	/*
+	 * Unless the index AM already produced the returnable tuple via
+	 * amgettransform above (in xs_hitup), set the original index tuple that
+	 * amgetbatch stored in currTuples in xs_itup.
+	 */
+	if (amgettransform == NULL)
+		scan->xs_itup = (IndexTuple) (scanBatch->currTuples +
+									  scanBatch->items[scanPos->item].tupleOffset);
 
 	/*
 	 * Set visibility info for the current scanPos item (plus possibly some
diff --git a/src/backend/access/index/amapi.c b/src/backend/access/index/amapi.c
index 36dd45553..a6b52474c 100644
--- a/src/backend/access/index/amapi.c
+++ b/src/backend/access/index/amapi.c
@@ -66,6 +66,7 @@ GetIndexAmRoutine(Oid amhandler)
 	Assert(routine->amgetbatch != NULL || routine->amkillitemsbatch == NULL);
 	Assert(routine->amgetbatch != NULL || routine->amposreset == NULL);
 	Assert(routine->amgetbatch != NULL || !routine->amcanmarkpos);
+	Assert(routine->amgetbatch != NULL || routine->amgettransform == NULL);
 
 	return routine;
 }
diff --git a/src/backend/access/index/genam.c b/src/backend/access/index/genam.c
index 67900b3d6..dbdc709b0 100644
--- a/src/backend/access/index/genam.c
+++ b/src/backend/access/index/genam.c
@@ -134,6 +134,7 @@ RelationGetIndexScan(Relation indexRelation, int nkeys, int norderbys)
 	scan->batch_index_opaque_static = 0;
 	scan->batch_tuples_workspace = 0;
 	scan->batch_table_opaque_size = 0;
+	scan->batch_index_opaque_dyn = 0;
 	scan->batch_base_offset = 0;
 
 	scan->xs_name_cstring_attnums = NULL;
diff --git a/src/backend/access/index/indexbatch.c b/src/backend/access/index/indexbatch.c
index be105c3cf..680ffd8c9 100644
--- a/src/backend/access/index/indexbatch.c
+++ b/src/backend/access/index/indexbatch.c
@@ -643,6 +643,7 @@ indexam_util_alloc_batch(IndexScanDesc scan)
 		{
 			/* We lazily compute batch_base_offset on scan's first call */
 			size_t		table_area = 0;
+			size_t		index_dyn_area = MAXALIGN(scan->batch_index_opaque_dyn);
 
 			if (scan->usebatchring)
 			{
@@ -653,8 +654,8 @@ indexam_util_alloc_batch(IndexScanDesc scan)
 				table_area = MAXALIGN(scan->batch_table_opaque_size);
 			}
 
-			/* ...though we always need an index AM area */
-			scan->batch_base_offset = table_area +
+			/* ...though we always need index AM areas */
+			scan->batch_base_offset = table_area + index_dyn_area +
 				scan->batch_index_opaque_static;
 		}
 
diff --git a/src/backend/access/nbtree/nbtree.c b/src/backend/access/nbtree/nbtree.c
index 714077d6b..dadbb4c0c 100644
--- a/src/backend/access/nbtree/nbtree.c
+++ b/src/backend/access/nbtree/nbtree.c
@@ -166,6 +166,7 @@ bthandler(PG_FUNCTION_ARGS)
 		.amgetbatch = btgetbatch,
 		.amunguardbatch = btunguardbatch,
 		.amkillitemsbatch = btkillitemsbatch,
+		.amgettransform = NULL,
 		.amgetbitmap = btgetbitmap,
 		.amendscan = btendscan,
 		.amposreset = btposreset,
diff --git a/src/backend/access/rmgrdesc/gistdesc.c b/src/backend/access/rmgrdesc/gistdesc.c
index 67789e025..021f72fa0 100644
--- a/src/backend/access/rmgrdesc/gistdesc.c
+++ b/src/backend/access/rmgrdesc/gistdesc.c
@@ -66,6 +66,7 @@ gist_desc(StringInfo buf, XLogReaderState *record)
 	switch (info)
 	{
 		case XLOG_GIST_PAGE_UPDATE:
+		case XLOG_GIST_PAGE_VACUUM:
 			out_gistxlogPageUpdate(buf, (gistxlogPageUpdate *) rec);
 			break;
 		case XLOG_GIST_PAGE_REUSE:
@@ -93,6 +94,9 @@ gist_identify(uint8 info)
 		case XLOG_GIST_PAGE_UPDATE:
 			id = "PAGE_UPDATE";
 			break;
+		case XLOG_GIST_PAGE_VACUUM:
+			id = "PAGE_VACUUM";
+			break;
 		case XLOG_GIST_DELETE:
 			id = "DELETE";
 			break;
diff --git a/src/backend/access/spgist/spgutils.c b/src/backend/access/spgist/spgutils.c
index 745435da3..47153b4b0 100644
--- a/src/backend/access/spgist/spgutils.c
+++ b/src/backend/access/spgist/spgutils.c
@@ -92,6 +92,7 @@ spghandler(PG_FUNCTION_ARGS)
 		.amgetbatch = NULL,
 		.amunguardbatch = NULL,
 		.amkillitemsbatch = NULL,
+		.amgettransform = NULL,
 		.amgetbitmap = spggetbitmap,
 		.amendscan = spgendscan,
 		.amposreset = NULL,
diff --git a/src/backend/executor/nodeIndexonlyscan.c b/src/backend/executor/nodeIndexonlyscan.c
index 858b295ff..3c8877528 100644
--- a/src/backend/executor/nodeIndexonlyscan.c
+++ b/src/backend/executor/nodeIndexonlyscan.c
@@ -131,18 +131,6 @@ IndexOnlyNext(IndexOnlyScanState *node)
 			}
 		}
 
-		/*
-		 * We don't currently support rechecking ORDER BY distances.  (In
-		 * principle, if the index can support retrieval of the originally
-		 * indexed value, it should be able to produce an exact distance
-		 * calculation too.  So it's not clear that adding code here for
-		 * recheck/re-sort would be worth the trouble.  But we should at least
-		 * throw an error if someone tries it.)
-		 */
-		if (scandesc->numberOfOrderBys > 0 && scandesc->xs_recheckorderby)
-			ereport(ERROR,
-					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-					 errmsg("lossy distance functions are not supported in index-only scans")));
 		return slot;
 	}
 
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
index 94fedf32c..624b6d0f8 100644
--- a/src/backend/optimizer/path/indxpath.c
+++ b/src/backend/optimizer/path/indxpath.c
@@ -951,9 +951,12 @@ build_index_paths(PlannerInfo *root, RelOptInfo *rel,
 	/*
 	 * 3. Check if an index-only scan is possible.  If we're not building
 	 * plain indexscans, this isn't relevant since bitmap scans don't support
-	 * index data retrieval anyway.
+	 * index data retrieval anyway.  If there are ordering operators then we
+	 * assume that an index-only scan is unsafe due to the difficulty with
+	 * holding index page pins sufficient to avoid concurrent TID recycling.
 	 */
 	index_only_scan = (scantype != ST_BITMAPSCAN &&
+					   orderbyclauses == NIL &&
 					   check_index_only(rel, index));
 
 	/*
diff --git a/contrib/bloom/blutils.c b/contrib/bloom/blutils.c
index 249af48e6..168842bc7 100644
--- a/contrib/bloom/blutils.c
+++ b/contrib/bloom/blutils.c
@@ -150,6 +150,7 @@ blhandler(PG_FUNCTION_ARGS)
 		.amgetbatch = NULL,
 		.amunguardbatch = NULL,
 		.amkillitemsbatch = NULL,
+		.amgettransform = NULL,
 		.amgetbitmap = blgetbitmap,
 		.amendscan = blendscan,
 		.amposreset = NULL,
diff --git a/doc/src/sgml/indexam.sgml b/doc/src/sgml/indexam.sgml
index dc8062ea5..84e413914 100644
--- a/doc/src/sgml/indexam.sgml
+++ b/doc/src/sgml/indexam.sgml
@@ -172,6 +172,7 @@ typedef struct IndexAmRoutine
     amgetbatch_function amgetbatch; /* can be NULL */
     amunguardbatch_function amunguardbatch; /* can be NULL */
     amkillitemsbatch_function amkillitemsbatch;	/* can be NULL */
+    amgettransform_function amgettransform; /* can be NULL */
     amgetbitmap_function amgetbitmap;   /* can be NULL */
     amendscan_function amendscan;
     amposreset_function amposreset; /* can be NULL */
@@ -716,27 +717,58 @@ ambeginscan (Relation indexRelation,
       and sibling page links).
      </para>
     </listitem>
+    <listitem>
+     <para>
+      <literal>scan-&gt;batch_index_opaque_dyn</literal>: the size of an
+      optional second per-batch opaque area, or 0 if the index AM does not need
+      one.  Unlike the area above, its size need not be known at compile time;
+      the index AM may choose it at the start of each scan.  It sits immediately
+      before the static area, and core code treats it as a single opaque
+      allocation that the index AM lays out however it likes (for example, to
+      carry per-item match metadata, such as a recheck flag or order-by
+      distances, that must travel with the batch).
+     </para>
+    </listitem>
     <listitem>
      <para>
       <literal>scan-&gt;batch_tuples_workspace</literal>: the size in bytes
       of the per-batch tuple storage workspace used for index-only scans
       (typically <literal>BLCKSZ</literal>), or 0 if the index AM does not
-      support index-only scans.  The workspace is accessible via
-      <structfield>batch-&gt;currTuples</structfield>.
+      support index-only scans.  The workspace is accessible via the batch's
+      <structfield>currTuples</structfield> field.  The index AM stores each
+      matching tuple here in its on-disk format (an
+      <structname>IndexTuple</structname>, or another on-disk tuple form used by
+      the AM); it is either exposed directly as
+      <literal>scan-&gt;xs_itup</literal>, or converted to the returnable tuple
+      later, by <function>amgettransform</function> (see below).
      </para>
     </listitem>
    </itemizedlist>
   </para>
 
+  <para>
+   These batch fields are usually set in <function>ambeginscan</function>, but an
+   index access method may instead set any of them in
+   <function>amrescan</function> when their value cannot be determined until then.
+   For example, the size of the dynamic opaque area might depend on whether this
+   is an <link linkend="indexes-index-only-scans">index-only scan</link>
+   (<literal>scan-&gt;xs_want_itup</literal>), which core code only sets after
+   <function>ambeginscan</function> has returned; such an access method sizes
+   <literal>scan-&gt;batch_index_opaque_dyn</literal> in
+   <function>amrescan</function> instead.  This is safe because no batch is ever
+   allocated before the first <function>amrescan</function> call.
+  </para>
+
   <para>
    An <function>amgetbatch</function> access method whose recheck requirement is
    a fixed property of the whole scan (rather than something that varies from
    one matching item to the next) should also set
    <literal>scan-&gt;xs_recheck</literal> here, in
-   <function>ambeginscan</function>, since the value applies to every item the
-   scan returns.  The value set here persists across any subsequent
-   <function>amrescan</function> calls.  B-tree (always false) and hash (always
-   true) work this way.
+   <function>ambeginscan</function>: the value then applies to every item the
+   scan returns, and persists across any subsequent
+   <function>amrescan</function> calls.  See <function>amgetbatch</function>
+   below, which describes both this whole-scan case and the per-item case in
+   detail.
   </para>
 
   <para>
@@ -758,6 +790,13 @@ amrescan (IndexScanDesc scan,
    remains the same.
   </para>
 
+  <para>
+   <function>amrescan</function> is also where an
+   <function>amgetbatch</function> access method sets any of the batch fields
+   described under <function>ambeginscan</function> above whose value could not
+   be determined until now.
+  </para>
+
   <para>
 <programlisting>
 bool
@@ -894,23 +933,75 @@ amgetbatch (IndexScanDesc scan,
   </para>
 
   <para>
-   Index access methods using <function>amgetbatch</function> must set
-   <literal>scan-&gt;xs_recheck</literal> to indicate whether rechecking of
-   scan keys is required, in the same way as <function>amgettuple</function>
-   does. However, <literal>scan-&gt;xs_recheck</literal> must be set consistently
-   for an entire scan rather than varying on a per-tuple basis. This is a key
-   difference from <function>amgettuple</function>, which can set
-   <literal>scan-&gt;xs_recheck</literal> independently for each tuple it returns.
-   Index access methods that require granular control over
-   <literal>scan-&gt;xs_recheck</literal> must use the <function>amgettuple</function>
-   interface instead of <function>amgetbatch</function>.
+   Index access methods using <function>amgetbatch</function> must convey
+   whether the scan keys need to be rechecked, via
+   <literal>scan-&gt;xs_recheck</literal>, just as
+   <function>amgettuple</function> access methods do.  Unlike
+   <function>amgettuple</function>, however, an
+   <function>amgetbatch</function> access method cannot set
+   <literal>scan-&gt;xs_recheck</literal> at the point an individual item is
+   returned, because the interface decouples the order of
+   <function>amgetbatch</function> calls from the order in which items are
+   later returned to the scan.  When the recheck requirement is a fixed
+   property of the whole scan, the index access method instead sets
+   <literal>scan-&gt;xs_recheck</literal> once, at scan start (in its
+   <function>ambeginscan</function> routine): B-tree always sets it false, and
+   hash always sets it true.  When the requirement instead varies from one
+   matching item to the next, the index access method records the per-item
+   value in the batch and provides an <function>amgettransform</function>
+   callback (see below), which the table AM invokes for each returned item to
+   set <literal>scan-&gt;xs_recheck</literal> from that recorded state; GiST
+   works this way.
   </para>
 
   <para>
-   Similarly, the <function>amgetbatch</function> interface does not currently
-   support index-only scans that return data in the form of a
-   <structname>HeapTuple</structname> pointer stored in
-   <literal>scan-&gt;xs_hitup</literal>.
+   An <function>amgetbatch</function> access method that supports index-only
+   scans must supply the scan's returnable tuple for each matching item, and
+   must do so in one of exactly two ways.  Which one applies is a fixed
+   property of the access method, determined by whether it provides an
+   <function>amgettransform</function> callback:
+   <itemizedlist>
+    <listitem>
+     <para>
+      If the index access method does <emphasis>not</emphasis> provide
+      <function>amgettransform</function>, it must store each matching tuple
+      in the batch's <structfield>currTuples</structfield> workspace as an
+      on-disk <structname>IndexTuple</structname> whose layout is exactly what
+      <literal>scan-&gt;xs_itupdesc</literal> describes.  The table AM exposes
+      those stored bytes directly as <literal>scan-&gt;xs_itup</literal> and
+      deforms them against <literal>xs_itupdesc</literal> (just as for an
+      <function>amgettuple</function> index-only scan); the index access
+      method must not set <literal>scan-&gt;xs_itup</literal> itself.  Among
+      the core access methods only B-tree uses this path, because it stores
+      the original indexed values unchanged, so the stored tuple already
+      matches <literal>xs_itupdesc</literal>.
+     </para>
+    </listitem>
+    <listitem>
+     <para>
+      Otherwise the index access method must provide an
+      <function>amgettransform</function> callback that produces the
+      returnable tuple in <literal>scan-&gt;xs_hitup</literal> (a
+      <structname>HeapTuple</structname> matching
+      <literal>scan-&gt;xs_hitupdesc</literal>).  This gives the access method
+      complete freedom to form that tuple from whatever it stored in
+      <structfield>currTuples</structfield>, in whatever on-disk format suits
+      it.  GiST uses this path, because the representation it
+      stores differs from the indexed value and so could not satisfy the
+      <literal>xs_itupdesc</literal> layout directly.
+     </para>
+    </listitem>
+   </itemizedlist>
+   The first path is generic, but useful only to an access method that &mdash;
+   like B-tree &mdash; already stores tuples in exactly the indexed-attribute
+   format; an access method that stores some other representation must take
+   the second path.  The two paths are mutually exclusive: an
+   <function>amgetbatch</function> access method takes one or the other, never
+   both.  (For historical reasons an <function>amgettuple</function> access
+   method is allowed to set both <literal>scan-&gt;xs_itup</literal> and
+   <literal>scan-&gt;xs_hitup</literal> for the same scan &mdash; the
+   heap-tuple form is then used &mdash; but that latitude is a legacy quirk
+   that <function>amgetbatch</function> deliberately does not repeat.)
   </para>
 
   <para>
@@ -940,8 +1031,10 @@ amunguardbatch (IndexScanDesc scan,
    is not even required to use the standard helper
    <function>indexam_util_unlock_batch</function> to manage it.  In practice,
    though, most or all index AMs will use that helper and hold the simplest
-   possible interlock: each guarded B-tree or hash batch keeps a single
-   buffer pin on the one index page the batch came from.  See <xref
+   possible interlock: each guarded B-tree, hash, or GiST batch keeps a
+   single buffer pin on the one index page the batch came from.  (The
+   <quote>virtual</quote> nearest-neighbor batches that GiST uses for ordered
+   scans are not guarded, and hold no such pin.)  See <xref
     linkend="index-locking"/> for details on buffer pin management during
    index scans.  This function will be called at most once for each guarded
    batch; it is not called when the index AM has already unguarded the batch
@@ -985,8 +1078,8 @@ amkillitemsbatch (IndexScanDesc scan,
    <function>amgetbatch</function> index AMs (those that don't can leave
    the field set to <literal>NULL</literal>), but doing so is recommended for
    performance, as it allows future scans to skip known-dead index entries.
-   Both core index access methods that currently support
-   <function>amgetbatch</function> (B-tree and hash) implement
+   All three core index access methods that currently support
+   <function>amgetbatch</function> (B-tree, hash, and GiST) implement
    <literal>LP_DEAD</literal> marking, though third-party index access methods
    are free to choose whether to implement this feature.  The table AM may
    call <function>tableam_util_scanpos_killitem</function> to mark dead items as
@@ -1028,7 +1121,7 @@ amkillitemsbatch (IndexScanDesc scan,
    <command>VACUUM</command> recycling table TIDs &mdash; so it would be
    unsafe to assume that index entries still point to the same heap/table
    tuples.  Since <literal>LP_DEAD</literal> marking is only an optimization
-   hint, it is always safe to skip it.  Both B-tree and hash use this
+   hint, it is always safe to skip it.  B-tree, hash, and GiST use this
    approach.
   </para>
 
@@ -1067,6 +1160,41 @@ amkillitemsbatch (IndexScanDesc scan,
 
   <para>
 <programlisting>
+void
+amgettransform (IndexScanDesc scan,
+                IndexScanBatch batch,
+                int item);
+</programlisting>
+   Called by the table AM as it returns each matching item
+   (<replaceable>item</replaceable> is an index into the batch's
+   <structfield>items</structfield> array) of an <function>amgetbatch</function>
+   scan, to set up the scan's per-tuple output from per-item state that the
+   access method recorded in the batch.  This is needed when that output cannot
+   be a fixed property of the whole scan.  An access method may use it to set
+   <literal>scan-&gt;xs_recheck</literal> (when the need to recheck the scan
+   conditions varies from one matching item to the next), to set
+   <structfield>xs_orderbyvals</structfield> and
+   <structfield>xs_recheckorderby</structfield> for an ordered
+   (nearest-neighbor) scan, and to set <literal>scan-&gt;xs_hitup</literal> for
+   an index-only scan whose returnable tuple must be reconstructed rather than
+   returned directly as a stored index tuple.
+  </para>
+
+  <para>
+   Implementing <function>amgettransform</function> is optional, and is only
+   meaningful together with <function>amgetbatch</function>.  An access method
+   need only provide it when some part of its per-tuple output varies from one
+   matching item to the next.  When every such output is instead a fixed
+   property of the whole scan &mdash; or, for index-only scans, is the on-disk
+   index tuple returned directly via <literal>scan-&gt;xs_itup</literal> &mdash;
+   the field can be left <literal>NULL</literal>, as B-tree and hash do.  GiST
+   provides one because parts of its per-tuple output (the recheck flag, the
+   <literal>ORDER BY</literal> distances, and the reconstructed index-only
+   tuples) vary per matching item, as described above.
+  </para>
+
+  <para>
+<programlisting>
 int64
 amgetbitmap (IndexScanDesc scan,
              TIDBitmap *tbm);
@@ -1361,8 +1489,26 @@ amtranslatecmptype (CompareType cmptype, Oid opfamily, Oid opcintype);
   </para>
 
   <para>
-   Note that <function>amgetbatch</function> scans do not currently support
-   ordering operators.
+   An <function>amgetbatch</function> access method can support ordering
+   operators by providing an <function>amgettransform</function> callback: it
+   records each matching item's ordering values in the batch, and the table AM
+   calls <function>amgettransform</function> as it returns each item to set
+   <structfield>xs_orderbyvals</structfield> and
+   <structfield>xs_recheckorderby</structfield> from that recorded state.  GiST
+   uses this for nearest-neighbor scans.  As with
+   <literal>scan-&gt;xs_recheck</literal>, these values cannot be set directly as
+   items are returned.
+  </para>
+
+  <para>
+   Scans that use ordering operators are never planned as index-only scans.
+   Because an ordered scan can collect matching items from many index leaf
+   pages without retaining a buffer pin on any of them (GiST's
+   <quote>virtual</quote> nearest-neighbor batches work this way), it has no
+   pin to serve as the interlock against concurrent TID recycling that an
+   index-only scan depends on (see <xref linkend="index-locking"/>).  The
+   planner therefore costs and executes such scans as plain index scans, which
+   always fetch and recheck the heap tuple.
   </para>
 
   <para>
diff --git a/src/test/modules/dummy_index_am/dummy_index_am.c b/src/test/modules/dummy_index_am/dummy_index_am.c
index 3f5be6082..c6990cab5 100644
--- a/src/test/modules/dummy_index_am/dummy_index_am.c
+++ b/src/test/modules/dummy_index_am/dummy_index_am.c
@@ -338,6 +338,7 @@ dihandler(PG_FUNCTION_ARGS)
 		.amgetbatch = NULL,
 		.amunguardbatch = NULL,
 		.amkillitemsbatch = NULL,
+		.amgettransform = NULL,
 		.amgetbitmap = NULL,
 		.amendscan = diendscan,
 		.amposreset = NULL,
diff --git a/src/test/modules/index/specs/killtuples.spec b/src/test/modules/index/specs/killtuples.spec
index 59e58adf6..d65e3bfff 100644
--- a/src/test/modules/index/specs/killtuples.spec
+++ b/src/test/modules/index/specs/killtuples.spec
@@ -47,6 +47,9 @@ step result { SELECT ((heap_blks_read + heap_blks_hit - counter.heap_accesses) >
 
 step access { EXPLAIN (ANALYZE, COSTS OFF, TIMING OFF, SUMMARY OFF, BUFFERS OFF) SELECT * FROM kill_prior_tuple WHERE key = 1; }
 
+# nearest-neighbor (order-by operator) scan (cannot set LP_DEAD bits)
+step access_ordered { EXPLAIN (ANALYZE, COSTS OFF, TIMING OFF, SUMMARY OFF, BUFFERS OFF) SELECT * FROM kill_prior_tuple ORDER BY key <-> 1; }
+
 step delete { DELETE FROM kill_prior_tuple; }
 
 step drop_table { DROP TABLE IF EXISTS kill_prior_tuple; }
@@ -96,6 +99,18 @@ permutation
   measure access flush result
   drop_table drop_ext_btree_gist
 
+# GiST doesn't set LP_DEAD bits for ordered scans, so every access re-visits
+# the heap
+permutation
+  create_table fill_500 create_ext_btree_gist create_gist flush
+  disable_seq disable_bitmap
+  measure access_ordered flush result
+  measure access_ordered flush result
+  delete flush
+  measure access_ordered flush result
+  measure access_ordered flush result
+  drop_table drop_ext_btree_gist
+
 # Test gist, but with fewer rows (tests for an old bug where
 # gistkillitems didn't remove items on the root page)
 permutation
diff --git a/src/test/regress/sql/gist.sql b/src/test/regress/sql/gist.sql
index 6f1fc65f1..369eb4576 100644
--- a/src/test/regress/sql/gist.sql
+++ b/src/test/regress/sql/gist.sql
@@ -65,7 +65,7 @@ select p from gist_tbl where p <@ box(point(0,0), point(0.5, 0.5));
 -- execute the same
 select p from gist_tbl where p <@ box(point(0,0), point(0.5, 0.5));
 
--- Also test an index-only knn-search
+-- Also test a knn-search
 explain (costs off)
 select p from gist_tbl where p <@ box(point(0,0), point(0.5, 0.5))
 order by p <-> point(0.201, 0.201);
@@ -109,7 +109,7 @@ select b from gist_tbl where b <@ box(point(5,5), point(6,6));
 -- execute the same
 select b from gist_tbl where b <@ box(point(5,5), point(6,6));
 
--- Also test an index-only knn-search
+-- Also test a knn-search
 explain (costs off)
 select b from gist_tbl where b <@ box(point(5,5), point(6,6))
 order by b <-> point(5.2, 5.91);
@@ -164,7 +164,9 @@ explain (verbose, costs off)
 select count(*) from gist_tbl;
 select count(*) from gist_tbl;
 
--- This case isn't supported, but it should at least EXPLAIN correctly.
+-- An ordering-operator (nearest-neighbor) scan is never planned as an
+-- index-only scan, so this lossy-distance case runs as a plain index scan that
+-- rechecks the distances against the heap tuple.
 explain (verbose, costs off)
 select p from gist_tbl order by circle(p,1) <-> point(0,0) limit 1;
 select p from gist_tbl order by circle(p,1) <-> point(0,0) limit 1;
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index ccc678ba8..7758c5406 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -1066,6 +1066,8 @@ GBT_NUMKEY_R
 GBT_VARKEY
 GBT_VARKEY_R
 GENERAL_NAME
+GISTBatchData
+GISTBatchItem
 GISTBuildBuffers
 GISTBuildState
 GISTDeletedPageContents
-- 
2.53.0

